export declare type AtomSubscription<T> = (value: T) => void;
export declare type AtomOptions = {
    name: string;
};
export declare class Atom<T> {
    private _value;
    private _subscriptions;
    private _name?;
    constructor(initialValue: T extends Function ? () => T : T | (() => T), opts?: AtomOptions);
    get name(): string | undefined;
    get value(): T;
    set value(value: T);
    subscribe(subscription: AtomSubscription<T>): () => void;
}
/** Create a new atom function with options */
export declare const createAtom: <T>(initialValue: T extends Function ? () => T : T | (() => T), opts?: AtomOptions) => Atom<T>;
