"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createAtom = exports.Atom = void 0;
class Atom {
    _value;
    _subscriptions;
    _name;
    // eslint-disable-next-line @typescript-eslint/ban-types
    constructor(initialValue, opts) {
        // eslint-disable-next-line @typescript-eslint/no-unsafe-assignment
        this._value = typeof initialValue === 'function' ? initialValue() : initialValue;
        this._subscriptions = [];
        this.subscribe = this.subscribe.bind(this);
        this._name = opts?.name;
    }
    get name() {
        return this._name;
    }
    get value() {
        return this._value;
    }
    set value(value) {
        this._value = value;
        this._subscriptions.forEach((cb) => cb(value));
    }
    subscribe(subscription) {
        this._subscriptions.push(subscription);
        return () => {
            this._subscriptions = this._subscriptions.filter((cb) => cb !== subscription);
        };
    }
}
exports.Atom = Atom;
/** Create a new atom function with options */
const createAtom = (
// eslint-disable-next-line @typescript-eslint/ban-types
initialValue, opts) => new Atom(initialValue, opts);
exports.createAtom = createAtom;
//# sourceMappingURL=Atom.js.map