import type { Atom } from './Atom';
export declare type SetAtomValue<T> = T extends Function ? (prevState: T) => T : T | ((prevState: T) => T);
/** React hook that returns a tuple with reactive atom value and update function  */
export declare const useAtom: <T>(atom: Atom<T>) => [T, (value: SetAtomValue<T>) => void];
